b		equ byte ptr		; Silly equs
w		equ word ptr		;
o		equ offset		;
s		equ short		;
f		equ far ptr		;

;flat_files	equ 1			; If defined, local files

; Solids

nPlats		equ 120			; This many
nSolids		equ nPlats		;

; Screen positions

		; The View_Width must be divisible by 16

View_Width_P	equ 208 / 16		; Width in paragraphs
View_Width	equ View_Width_P * 16	; In pixels

View_Height_P	equ 150	/ 16		; This high
View_Height	equ View_Height_P * 16	; In lines

View_LHS	equ ((320-View_Width)/4)*2	; LHS of window (even)
View_RHS	equ View_LHS + View_Width -1 	; RHS

View_TOP	equ 201-(View_Height+6)		; TOP of window
View_BOTT	equ View_TOP + View_Height -1	; Bottom

View_Offset	equ (View_TOP * 320) + View_LHS	; First pixel (byte) of window

; Buffer screen data

		; All these are in paragraphs

Margin_X_P	equ 3				; This width 
Margin_X	equ Margin_X_P * 16		; In bytes

X_Step_P	equ View_Width_P + Margin_X_P	; Offset to next line
X_Step		equ X_Step_P * 16		; In bytes

Margin_Y_P	equ 48 * X_Step_P		; This many lines (/16)

Buff_Size_P	equ View_Height * X_Step_P	; Size of 'visible' buffer
Buff_Size	equ Buff_Size_P * 16		; In bytes

Buff_Offset_P	equ Margin_X_P + Margin_Y_P	; Margin in paras 
Buff_Offset	equ Buff_Offset_P * 16		; In bytes
Buff_End	equ Buff_Offset + Buff_Size	; Last visible line + 1

;Buff_Seg_Off_P	equ Buff_Offset_P + Buff_Size_P	; Offset to second buff

Buffer_Size_P	equ Buff_Size_P + 2*Margin_Y_P ; Total size

; Game defns

iCol		equ 020h		; The first block colour
nCols		equ 0100h-iCol		; This many block colours
