; Various nasty routines

; Write a number in ax to bx,dx

ShowDec16:	push ax			; Save regs
		push bx			;
		push di			;

		mov cx,bx		; Save X

		mov di,ax		; Shuffle regs

		mov bx,o PowersOfTen	; Digit values table

		mov ah,iBlank		; To be displayed for 0

SD_Lp:		call SD_CalcDigit	; Calc digit

		cmp al,0		; Zero ?
		jnz SD_1		; No

		mov al,ah		; Print ' ' or '0'
		call SD_Char		;

		jmp s SD_Next		; Do next digit

SD_1:		mov ah,iDigs		; Use 0 in future

		add al,ah		; Make the char
		call SD_Char		;

SD_Next:	add bx,2		; Next power of ten

		cmp w cs:[bx],1		; Last power of ten ?
		jnz SD_Lp		; No, continue

		call SD_CalcDigit	; Calc digit

		add al,iDigs		; Make char
		call SD_Char		; Show it

		pop di			; Restore
		pop bx			;
		pop ax			;

		ret			; Done

SD_CalcDigit:	mov al,-1		; Initial digit
	
SDCD_Lp:	inc al			; Inc digit

		sub di,CS:[bx]		; 16-bit

		jnc SDCD_Lp		; Try again

		add di,CS:[bx]		; Step back

		ret			; Done						

; Decimal char out

SD_Char:	push ax			; Save
		push bx			;
		push cx			;
		push dx			;
		push di			;

		mov bx,cx		;

		mov ah,0		;

		call Draw_Sprite	;		

		pop di			; Restore
		pop dx			;
		pop cx			;
		pop bx			;
		pop ax			;

		add cx,8		; Move right

		ret			; Done

; Random numbers

Rand_32:	PUSH cx			;
		PUSH bx			;

		CALL Rand_Inner		; Get next

		XOR al,dh		; Scramble it a bit
		XOR ah,dl		;

		POP bx			; Restore
		POP cx			;

		RET			; Done

Rand_Inner:	MOV ax,word ptr CS:Seed	; This is from Turbo Pascal
		MOV bx,word ptr CS:Seed+2;
		MOV cx,ax		;

		MUL word ptr CS:Nasty	;

		SHL cx,1		;
		SHL cx,1		;
		SHL cx,1		;

		ADD ch,cl		;
		ADD dx,cx		;
		ADD dx,bx		;

		SHL bx,1		;
		SHL bx,1		;

		ADD dx,bx		;
		ADD dh,bl		;

		MOV cl,5		;
		SHL bx,cl		;

		ADD dh,bl		;

		ADD ax,1		;
		ADC dx,0		;

		MOV word ptr CS:Seed,ax	;
		MOV word ptr CS:Seed+2,dx;

		RET			;

; Fixed data

Nasty:		DW 33797		; Nasty number

; Vars

Seed		DB "NIG!"		; Random number seed

