; Drivers for the sound-blaster

ns_FM		equ 0388h		; FM chips

Init_Noises:
		ret			; Done

; Clear the flags

Noise_Frame:	mov dx,ns_FM		; Clear the flags

		mov al,0BDh		;
		out dx,al		;

		inc dl			; Data

		call ns_Delay		; Pause

		mov al,020h		;
		out dx,al		;

		ret			; Done

; Collecting noise

ns_Collect:	ret

; Landing-noise

ns_Landing:	push dx			; Save
		push ax			;

		mov dx,ns_FM		; Point at the port

		mov al,0BDh		; Percussion port
		out dx,al		;

		inc dl			; Data

		call ns_Delay		; Pause

		mov al,021h		; Set it
		out dx,al		;

		pop ax			; Restore
		pop dx			;

		ret			; Done

; Delay >3.3uS

ns_Delay:	push ax			; Save

		mov al,20		; This long

ns_D_Lp:	dec al			; Loop
		jnz ns_D_Lp		;

		pop ax			; Restore
		ret			; Done

; Vars

